DCMTK - Bug #1153

XML and LUT export do not use locale-independent output routines
Description

The output routines that convert DICOM datasets or structured reports to XML use the std::iostream functions to print certain floating
point numbers (e.g. attribute values of OF and OD attributes, values of NUM content items in SR). These are not locale independent.
Should an application change the process-global locale with std::locale::global(), then in certain locales such as German a comma

instead of a point will be printed as decimal separator. Furthermore, iostream prints NaN values with sign bit as "

expected or supported by the conversion routines that convert XML back to DICOM. In these places,
OFStandard::ftoa() should be used, which is locale independent and prints NaN values without sign.

Also affected are routines that print certain lookup tables into a text file. In detail, the following methods need to be fixed:

o DSRNumericMeasurementValue::writeXML()

DcmOtherFloat::write XML()
DcmOtherDouble::write XML ()
DiCIELABLUT::createLUT()
DiIGSDFLUT::createLUT()

Reported 2025-02-17 by Mathieu Malaterre <mathieu.malaterre@gmail.com>.

-nan", which is not

History

#1 - 2025-02-20 12:39 - J6rg Riesmeier
- Assignee set to Jérg Riesmeier
- Target version set to 3.7.0

- Module set to demdata, demimgle, demsr

#2 - 2025-02-21 16:45 - J6rg Riesmeier

- Description updated

#3 - 2025-02-21 17:01 - J6rg Riesmeier
- Status changed from New to Closed

- Estimated time set to 4:00 h

Closed with commits ed8599114 and 52b82979a.
